from bintreenode import BinTreeNode
from bintree import *
"""A simple application to build and test a tree"""

def built_tree1():
    root = BinTreeNode( 'T' )

    temp = BinTreeNode( 'X' )
    root.set_left( temp )

    temp = BinTreeNode( 'B' )
    root.get_left().set_left( temp )

    temp = BinTreeNode( 'G' )
    root.get_left().set_right( temp )

    temp = BinTreeNode( 'Z' )
    root.get_left().get_right().set_left( temp )

    temp = BinTreeNode( 'C' )
    root.set_right( temp )

    temp = BinTreeNode( 'J' )
    root.get_right().set_left( temp )

    temp = BinTreeNode( 'R' )
    root.get_right().set_right( temp )

    temp = BinTreeNode( 'K' )
    root.get_right().get_right().set_left( temp )
    
    temp = BinTreeNode( 'M' )
    root.get_right().get_right().set_right( temp )
    
    bintree = BinTree( root )

    return bintree

def built_tree2():
    root = BinTreeNode( 'A' )
    temp = BinTreeNode( 'B' )
    root.set_right( temp )
    temp = BinTreeNode( 'C' )
    root.get_right().set_right( temp )

    temp1 = BinTreeNode( 'D' )
    temp.set_left( temp1 )
    temp1 = BinTreeNode( 'E' )
    temp.get_left().set_right( temp1 )
    temp1 = BinTreeNode( 'F' )
    temp.get_left().get_right().set_left( temp1 )

    temp2 = BinTreeNode( 'G' )
    temp1.set_right( temp2 )
    temp2 = BinTreeNode( 'H' )
    temp1.get_right().set_left( temp2 )

    bintree = BinTree( root )
    return bintree

def exam_tree( bintree ):
    """Perform various operations on a tree"""

    print( 'inorder traversal ...' )
    bintree.inorder()

    print( 'preorder traversal ...' )
    bintree.preorder()

    print( 'postorder traversal ...' )
    bintree.postorder()

    print( 'level order traversal ...' )
    bintree.levelorder()

    print( 'counting nodes : ', bintree.count() )

    print( 'height of the tree : ', bintree.height() )

def main():

    bintree = built_tree1()
    exam_tree( bintree )
    bintree = built_tree2()
    exam_tree( bintree )

main()
